Inductive rnum : Set :=
  | r0 : rnum  | r1 : rnum  | r2 : rnum  | r3 : rnum 
  | r4 : rnum  | r5 : rnum  | r6 : rnum  | r7 : rnum 
  | r8 : rnum  | r9 : rnum  | r10 : rnum | r11 : rnum
  | r12 : rnum | r13 : rnum | r14 : rnum | r15 : rnum
  | r16 : rnum | r17 : rnum | r18 : rnum | r19 : rnum
  | r20 : rnum | r21 : rnum | r22 : rnum | r23 : rnum
  | r24 : rnum | r25 : rnum | r26 : rnum | r27 : rnum
  | r28 : rnum | r29 : rnum | r30 : rnum | r31 : rnum.

Definition beq_rnum r r' : bool :=
  match r, r' with
  | r0, r0 => true
  | r1, r1 => true
  | r2, r2 => true
  | r3, r3 => true
  | r4, r4 => true
  | r5, r5 => true
  | r6, r6 => true
  | r7, r7 => true
  | r8, r8 => true
  | r9, r9 => true
  | r10, r10 => true
  | r11, r11 => true
  | r12, r12 => true
  | r13, r13 => true
  | r14, r14 => true
  | r15, r15 => true
  | r16, r16 => true
  | r17, r17 => true
  | r18, r18 => true
  | r19, r19 => true
  | r20, r20 => true
  | r21, r21 => true
  | r22, r22 => true
  | r23, r23 => true
  | r24, r24 => true
  | r25, r25 => true
  | r26, r26 => true
  | r27, r27 => true
  | r28, r28 => true
  | r29, r29 => true
  | r30, r30 => true
  | r31, r31 => true
  | _,  _  => false
  end.


(* MIPS register conventions *)
   (* from Xinyu's scap.v *)
Notation ra := r31.  (* return address proc *)
Notation zero := r0. (*always zero *)
Notation ast := r1.  (* assembler temporary *)
Notation v0 := r2.   (*v0 - v1 return values *)
Notation v1 := r3.
Notation a0 := r4.   (*a0 - a3 arguments *)
Notation a1 := r5.
Notation a2 := r6.
Notation a3 := r7.
Notation t0 := r8.   (*t0 - t9 caller saved temporary *)
Notation t1 := r9.
Notation t2 := r10. 
Notation t3 := r11.
Notation t4 := r12.
Notation t5 := r13.
Notation t6 := r14.
Notation t7 := r15.
Notation t8 := r24.
Notation t9 := r25.
Notation s0 := r16.  (*s0 - s7 callee saved temporary *)
Notation s1 := r17.
Notation s2 := r18.
Notation s3 := r19.
Notation s4 := r20.
Notation s5 := r21.
Notation s6 := r22.
Notation s7 := r23.
Notation k0 := r26.
Notation k1 := r27.
Notation gp := r28.
Notation sp := r29.
Notation fp := r30.