Set Implicit Arguments.

Notation "'do' x <-- o ; f" :=
  (match o with Some y => (fun x => f) y | None => None end)
  (at level 200, x ident).
Notation ret := Some (only parsing).

Notation optPred :=
  (fun opt:option _ => fun f =>
    match opt with
      | Some t => f t
      | None => False
    end).

Inductive optionT (A:Type) : Type :=
  | SomeT : A -> optionT A
  | NoneT.

Notation optPredT :=
  (fun opt:optionT _ => fun f =>
    match opt with
      | SomeT t => f t
      | NoneT => False
    end).

