Require Import RNum32.


Section RFile.

Notation rval := nat.

Definition rfile := rnum -> rval.

Definition set (rf:rfile) (r:rnum) (v:rval) : rfile :=
  fun r' => if beq_rnum r r' then v else rf r'.

Definition get (rf:rfile) (r:rnum) : rval :=
  if beq_rnum r0 r then 0 else rf r.

End RFile.
